function ssoServer(PORT,CLIENT_DOMAIN,CAS_DOMAIN,IGNORE_CAS_PATTERN,APPLICATION_NAME,TOKEN_CONFIG) {
  var express = require('express')
  var ConnectCas = require('./connect-cas2/index');
  var bodyParser = require('body-parser');
  var session = require('express-session');
  var cookieParser = require('cookie-parser');
  var MemoryStore = require('session-memory-store')(session);
  var fs = require('fs')
  var app = express()
  //使用gzip加速
  var compression = require('compression');
  app.use(compression());
  app.disable('x-powered-by');
  app.use(cookieParser());
  let PublicPath = APPLICATION_NAME !== '*' ? '/' + APPLICATION_NAME : ''
  app.use(session({
    name: 'NSESSIONID',
    secret: 'Hello I am a long long long secret',
    store: new MemoryStore(),  // or other session store
    resave:false,//强制保存session,即使它没变化
    saveUninitialized:true, //强制将未初始化的session存储，默认为true
    cookie: { path:APPLICATION_NAME !== '*' ? '/' + APPLICATION_NAME : '/' , secure: false }
  }));
  var validatePath = APPLICATION_NAME === '*' ? '/cas/validate' : '/'+ APPLICATION_NAME+'/cas/validate'
  var casClient = new ConnectCas({
    debug: true,
    ignore: [
      new RegExp(IGNORE_CAS_PATTERN)
    ],
    match: [],
    servicePrefix: CLIENT_DOMAIN,
    serverPath: CAS_DOMAIN,
    paths: {
      validate: validatePath,
      serviceValidate: '/cas/p3/serviceValidate',
      proxy:'',
      proxyCallback:'',
      login: '/cas/login',
      logout: '/cas/logout',

    },

    rejectUnauthorized:false,
    restletIntegration:false,
    gateway: false,
    renew: false,
    slo: true,
    cache: {
      enable: false,
      ttl: 5 * 60 * 1000,
      filter: []
    },
    fromAjax: {
      header: 'x-client-ajax',
      status: 418
    }
  });
  app.use((req,res,next) => {
    req.sn = req.path
    next()
  })
  app.use(casClient.core());
  app.use(bodyParser.json());
  app.use(bodyParser.urlencoded({ extended: true }));
  var http = require('http').Server(app)
  var path = require('path');
  let DistPath = '../../../dist'
  app.set('views', path.join(__dirname, DistPath + PublicPath));
  app.set('view engine', 'ejs');
  app.use(express.static(path.join(__dirname, DistPath)));
  var httpProxy = require('http-proxy-middleware');
  var fsExit = fs.existsSync(path.join(__dirname, DistPath + PublicPath +'/static/HttpProxyConfig/HttpProxyConfig.js'))
  function httpProxyFun(exists) {
    console.log(exists ? '存在代理配置服务端需要设置代理':'代理数据不存在，服务器不需要做代理请求处理');
    if(exists){
      require(path.join(__dirname, DistPath + PublicPath +'/static/globalConfig/globalConfig.js'));
      require(path.join(__dirname, DistPath + PublicPath +'/static/HttpProxyConfig/HttpProxyConfig.js'));
      for(let item of HttpProxyConfig){
        app.use( PublicPath + item.path , httpProxy({
          target: item.target, // 目标服务器 host
          changeOrigin: true,               // 默认false，是否需要改变原始主机头为目标URL
          ws: false,                         // 是否代理websockets
          pathRewrite: function(path,req){
            return PublicPath + path
          }
        }))
      }
    }
  };
  httpProxyFun(fsExit)
  if(APPLICATION_NAME !== '*'){
    app.get('/', function(req, res, next) {
      res.redirect('/' + APPLICATION_NAME)
    })
  }
  app.get( PublicPath + '/*', function(req, res, next) {
    var regTest =  new RegExp(IGNORE_CAS_PATTERN);
    if(regTest.test(req.url)){
      res.sendFile(path.join(__dirname,DistPath + PublicPath + '/static/' + req.url),
        function (req1,res1) {
          if(req1 && req1.status === 404){
            res.send(JSON.stringify(req1))
          }
        })
    }else if(req.url !== PublicPath + '/logout'){
      var attributes = req.session.cas.attributes
      console.log('cas返回数据' , attributes)
      console.log('TOKEN_CONFIG：' , attributes)
      let willBackToken = new Set()
      for(let item  of TOKEN_CONFIG){
        let keyCas = Object.keys(item)[0]
        let keyBack = item[keyCas]
        let valBack = attributes[keyCas][0]
        let tonkenItem = `${keyBack}=${valBack}`
        willBackToken.add(tonkenItem)
      }
      willBackToken.add('username' + '=' + attributes.username[0])
      res.setHeader('Set-Cookie', Array.from(willBackToken));
      res.render('index',{
		  CAS_DOMAIN:CAS_DOMAIN
	  })
    }else { //登出
      // Do whatever you like here, then call the logout middleware
      casClient.logout()(req, res, next);
    }
  })
  if (process.env.PORT) {
    console.log('> Listening at ' + process.env.PORT + '\n')
    http.listen(process.env.PORT)
  } else {
    http.listen(PORT)
    console.log('> Listening at ' + PORT + '\n')
  }
}
module.exports = ssoServer;
